// DaoSet.cpp : implementation of the CDaoSet class
//

#include "stdafx.h"
#include "Dao.h"
#include "DaoSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDaoSet implementation

IMPLEMENT_DYNAMIC(CDaoSet, CDaoRecordset)

CDaoSet::CDaoSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CDaoSet)
	m_COURSEID = _T("");
	m_COURSETITLE = _T("");
	m_PHOURS = 0;
	m_nFields = 8;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}

CString CDaoSet::GetDefaultSQL()
{
	return _T("[COURSE]");
}

void CDaoSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CDaoSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Text(pFX, _T("[COURSEID]"), m_COURSEID);
	DFX_Text(pFX, _T("[COURSETITLE]"), m_COURSETITLE);
	DFX_Long(pFX, _T("[PHOURS]"), m_PHOURS);
	DFX_Binary(pFX, _T("[PBINARY]"), m_PBINARY);
	DFX_DateTime(pFX, _T("[PDATE]"), m_PDATE);
	DFX_DateTime(pFX, _T("[PTIME]"), m_PTIME);
	DFX_DateTime(pFX, _T("[PTIMESTAMP]"), m_PTIMESTAMP);
	DFX_LongBinary(pFX, _T("[PRASTER]"), m_PRASTER);
	//}}AFX_FIELD_MAP
//DFX_DateTime

// Ti funkce DFX_Date, kter vygeneruje ClassWizard pro atributy
// PDATE, PTIME, PTIMESTAMP nahradme run temi fcemi 
// DFX_DateTime, jak ukazuje pklad a a u prvk m_PDATE, m_PTIME
// a m_PTIMESTAMP zmnme jejich typ vygenerovan ClassWizard
// z CTime na COleDateTime.

}


/////////////////////////////////////////////////////////////////////////////
// CDaoSet diagnostics

#ifdef _DEBUG
void CDaoSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CDaoSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG
