// DaoView.cpp : implementation of the CDaoView class
//

#include "stdafx.h"
#include "Dao.h"

#include "DaoSet.h"
#include "DaoDoc.h"
#include "DaoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define LOG 1 // 1 = napojen na PRASTER, 0 = nenapojen na PRASTER 

/////////////////////////////////////////////////////////////////////////////
// CDaoView

IMPLEMENT_DYNCREATE(CDaoView, CDaoRecordView)

BEGIN_MESSAGE_MAP(CDaoView, CDaoRecordView)
	//{{AFX_MSG_MAP(CDaoView)
	ON_COMMAND(ID_ADD_RECORD, OnAddRecord)
	ON_COMMAND(ID_DELET_RECORD, OnDeletRecord)
	ON_BN_CLICKED(IDC_BUT_UPDATE, OnButUpdate)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CDaoRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CDaoRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CDaoRecordView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDaoView construction/destruction

CDaoView::CDaoView()
	: CDaoRecordView(CDaoView::IDD)
{
	//{{AFX_DATA_INIT(CDaoView)
	m_pSet = NULL;
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_bAddMode = FALSE;
	m_bFirstCallRaster = 1;
	m_bAktuatizovatRaster = 0;
}

CDaoView::~CDaoView()
{
}

void CDaoView::DoDataExchange(CDataExchange* pDX)
{
	CDaoRecordView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDaoView)
	DDX_FieldText(pDX, IDC_EDIT1, m_pSet->m_COURSEID, m_pSet);
	DDX_FieldText(pDX, IDC_EDIT2, m_pSet->m_COURSETITLE, m_pSet);
	DDX_FieldText(pDX, IDC_EDIT3, m_pSet->m_PHOURS, m_pSet);
	DDX_FieldText(pDX, IDC_EDIT4, m_pSet->m_PDATE, m_pSet);
	DDX_FieldText(pDX, IDC_EDIT5, m_pSet->m_PTIME, m_pSet);
	DDX_FieldText(pDX, IDC_EDIT6, m_pSet->m_PTIMESTAMP, m_pSet);
	//}}AFX_DATA_MAP
	DoRasterExchange(pDX); // Uivatelsk fce	
	DoBinaryExchange(pDX); // Uivatelsk fce	
}

BOOL CDaoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CDaoRecordView::PreCreateWindow(cs);
}

void CDaoView::OnInitialUpdate()
{
	CDaoDoc* pDoc = (CDaoDoc*)GetDocument();
	m_pSet = &pDoc->m_daoSet;
	m_pSet->m_pDatabase = pDoc->GetDatabase();
	if (!m_pSet->m_pDatabase->IsOpen())
		return;

	CDaoRecordView::OnInitialUpdate();
}

/////////////////////////////////////////////////////////////////////////////
// CDaoView printing

BOOL CDaoView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDaoView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDaoView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDaoView diagnostics

#ifdef _DEBUG
void CDaoView::AssertValid() const
{
	CDaoRecordView::AssertValid();
}

void CDaoView::Dump(CDumpContext& dc) const
{
	CDaoRecordView::Dump(dc);
}

CDaoDoc* CDaoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDaoDoc)));
	return (CDaoDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDaoView database support
CDaoRecordset* CDaoView::OnGetRecordset()
{
	return m_pSet;
}


/////////////////////////////////////////////////////////////////////////////
// CDaoView message handlers

BOOL CDaoView::OnMove(UINT nIDMoveCommand) 
{
	if (m_bAddMode) { 
		m_bAddMode = FALSE;	
		UpdateData(TRUE);
		m_pSet->Update();
		m_pSet->Requery();
		UpdateData(TRUE);
	}
	return CDaoRecordView::OnMove(nIDMoveCommand);
}

void CDaoView::OnAddRecord() 
{
// If already in add mode, then complete previous new record
	if (m_bAddMode)
		OnMove(ID_RECORD_FIRST);
	m_pSet->AddNew();
	m_pSet->SetFieldNull(NULL);
	m_bAddMode = TRUE;
	UpdateData(FALSE);	
}

void CDaoView::OnDeletRecord() 
{
	m_pSet->Delete();   
	m_pSet->MoveNext();
	if (m_pSet->IsEOF()) m_pSet->MoveLast();
	if (m_pSet->IsBOF()) m_pSet->SetFieldNull(NULL);
	m_pSet->Requery();
	UpdateData(FALSE);		
}

void CDaoView::DoRasterExchange(CDataExchange* pDX)
{
#if LOG
	if (pDX->m_bSaveAndValidate)// Z "ovladacho prvku" do dat. prvku m_pSet->m_PRASTER
	{
		if (m_bAktuatizovatRaster == 1) 
		{
/*
	Do poloky PRASTER aktulnho zznamu zkopruji data z atributu
	PRASTER prvnho zznamu. Tato data jsou skladovna 
	v poli bajt CByteArray m_baCopieFirstPRASTER.
	Tm je otestovna monost zpisu do atributu typu RASTER. 
	Formt dat je DIB bitmapa. 
*/	
			m_nSizeRaster = m_baCopieFirstPRASTER.GetSize();	
			if (m_nSizeRaster != 0)
			{		
				HGLOBAL Data = GlobalAlloc(GMEM_MOVEABLE, m_nSizeRaster);
				if (Data == 0) return;	
				LPVOID  lpDataLok = GlobalLock( Data );
				m_lpDataByteRaster = (BYTE*)lpDataLok;

				for (DWORD nIndex = 0; nIndex < m_nSizeRaster; nIndex++)
				 m_lpDataByteRaster[nIndex]  = m_baCopieFirstPRASTER.GetAt(nIndex);        		

				CDaoDoc* pDoc = GetDocument();
				HGLOBAL hData = pDoc->m_daoSet.m_PRASTER.m_hData;
				GlobalUnlock( hData );
				HGLOBAL HandRet = GlobalFree( hData );
		
				// Nastavit nov data
				pDoc->m_daoSet.m_PRASTER.m_dwDataLength = m_nSizeRaster;
				pDoc->m_daoSet.m_PRASTER.m_hData = Data;

				pDoc->m_daoSet.SetFieldNull( &(pDoc->m_daoSet.m_PRASTER), FALSE );
				pDoc->m_daoSet.SetFieldDirty( &(pDoc->m_daoSet.m_PRASTER), TRUE );
			} // if (m_nSizeRaster != 0)	
			m_bAktuatizovatRaster = 0;
		}
	}
	else// Z dat. prvku m_pSet->m_PRASTER do "ovladacho prvku" 
	{
		DrawBitmapToView();	
		static RECT rec = {5,125,230,270};	
		InvalidateRect(&rec);	
	}
#endif
}

void CDaoView::DrawBitmapToView()
{
#if LOG
/**** Uivatelsk fce pro vykreslen bitmapy z poloky RASTER ***/
	#define P_BINFO ((BITMAPINFOHEADER*)lpDib)

	CDaoDoc* pDoc = GetDocument();
	HGLOBAL hData = pDoc->m_daoSet.m_PRASTER.m_hData;
	if (hData == 0) return;
	LPVOID  lpData = GlobalLock(hData);	
	m_nSizeRaster = ((BITMAPFILEHEADER*)lpData)->bfSize;
	m_lpDataByteRaster = (BYTE*)lpData;
	BYTE* lpDib = m_lpDataByteRaster + sizeof(BITMAPFILEHEADER);		
	BYTE* lpDibBits  = GetDibBitsAddr(lpDib);
	DWORD cxDib = P_BINFO->biWidth;
	DWORD cyDib = P_BINFO->biHeight; 
	CClientDC dc(this);
			
	long lNumRec = pDoc->m_daoSet.GetAbsolutePosition( );
	if ( lNumRec == 0){  // Prvn zznam
	  m_bAktuatizovatRaster = 0;
	  if ( m_bFirstCallRaster == 1 ) { // Prvn voln - uloen poloky	 
		SaveFirstPRASTER();
		m_bFirstCallRaster = 0; // Pole se ji znova ukldat nebude 
	  }	
	} 
	else // Druh i dal zznam
	if (m_bAktuatizovatRaster == 1)
	{
/*	Do poloky PRASTER aktulnho zznamu zkopruji data z atributu
	PRASTER prvnho zznamu. Tuto kopii se pozdji pokusm zapsat 
	do PRASTER jinho zznamu - aktulnho zznamu, na nm 
	kliknu na tlatko UPDATE PRASTER.
	Tm je otestovna monost zpisu do atributu typu RASTER 
	Formt dat je DIB bitmapa 
*/
		m_nSizeRaster = m_baCopieFirstPRASTER.GetSize();
		if (m_nSizeRaster != 0)
		{		
			HGLOBAL Data = GlobalAlloc(GMEM_MOVEABLE, m_nSizeRaster);			
			LPVOID  lpDataLok = GlobalLock( Data );
			m_lpDataByteRaster = (BYTE*)lpDataLok;

/*
 Zkoprovn obsahu poloky PRASTER prvnho zznamu uloenho 
 v poli m_baCopieFirstPRASTER do pole m_lpDataByteRaster	
*/
			for (DWORD nIndex = 0; nIndex < m_nSizeRaster; nIndex++)
		     m_lpDataByteRaster[nIndex]  = m_baCopieFirstPRASTER.GetAt(nIndex);        		

			// Zruit star data
			BOOL Er1 = GlobalUnlock( hData );
			HGLOBAL HandRet = GlobalFree( hData );
		
			// Nastavit nov data
			pDoc->m_daoSet.m_PRASTER.m_dwDataLength = m_nSizeRaster;
			pDoc->m_daoSet.m_PRASTER.m_hData = Data;
		
			lpDib = m_lpDataByteRaster + sizeof(BITMAPFILEHEADER); 
			lpDibBits  = GetDibBitsAddr(lpDib);
			cxDib = P_BINFO->biWidth;
			cyDib = P_BINFO->biHeight; 					
		}
	
	}
	 
	/******/ SetDIBitsToDevice( /*****************************/
    dc.m_hDC,		// handle of device context 
    10,		// x-coordinate of upper-left corner of dest. rect. 
    150,	// y-coordinate of upper-left corner of dest. rect. 
    cxDib,			// source rectangle width 
    cyDib,			// source rectangle height 
    0,		// x-coordinate of lower-left corner of source rect. 
    0,		// y-coordinate of lower-left corner of source rect. 
    0,				// first scan line in array 
    cyDib,			// number of scan lines 
    (LPSTR)lpDibBits,		// address of array with DIB bits 
    (BITMAPINFO*)lpDib,// address of structure with bitmap info. 
    DIB_RGB_COLORS	   // RGB or palette indices 
   );	
 	GlobalUnlock(hData);
#endif
}

BYTE* CDaoView::GetDibBitsAddr(BYTE* lpDib)
{
#if LOG
/* Uivatelsk fce pro zskn adresy (pole s DIB bity)
   jakoto vstupnho parametru SetDIBitsToDevice
*/   
#define P_BINFO ((BITMAPINFOHEADER*)lpDib)

DWORD dwNumColors = P_BINFO->biClrUsed;
WORD  dwBitCount = P_BINFO->biBitCount;
DWORD dwBitInfoSize = P_BINFO->biSize;	
 if (dwNumColors == 0)
	if (dwNumColors != 24) 
	  dwNumColors = 1L << dwBitCount;
	else
	  dwNumColors = 0;	
DWORD dwColorTableSize = dwNumColors * sizeof(RGBQUAD);
return lpDib + dwBitInfoSize + dwColorTableSize; 
#endif
#if 1 - LOG
return 0;
#endif
}

void CDaoView::OnDraw(CDC* pDC) 
{
#if LOG
	DrawBitmapToView();		
#endif		
}

void CDaoView::SaveFirstPRASTER()
{
#if LOG	
	// Kd pro uloen PRASTER z prvnho zznamu
   
/*  ulo obsah poloky PRASTER prvnho zznamu 
	(rStatus.m_lCurrentRecord == 0) do pole bajt
	CByteArray m_baCopieFirstPRASTER pro jeho ppadn pozdj
	pouit (m_bAktuatizovatRASTER == 1) - zkoprovn do jinho 
	zznamu.
*/	
	m_baCopieFirstPRASTER.SetSize(m_nSizeRaster);
	if (m_nSizeRaster > 0) 
	 for (DWORD nIndex = 0; nIndex < m_nSizeRaster; nIndex++)
	   m_baCopieFirstPRASTER.SetAt(nIndex, m_lpDataByteRaster[nIndex]);
#endif
}

void CDaoView::OnButUpdate() 
{
#if LOG
/*  Pi pesunu na jin zznam se provede
    (nebo m_bAktuatizovatRaster == 1) aktualizace poloky
	PRASTER hodnotou z prvnho zznamu a nastav se
	m_bAktuatizovatRaster = 0
*/	
	m_bAktuatizovatRaster = 1;	
	DrawBitmapToView();	
	static RECT rec = {5,125,230,270};	
	InvalidateRect(&rec);		
#endif	
}

void CDaoView::DoBinaryExchange(CDataExchange* pDX)
{
	if (pDX->m_bSaveAndValidate) 
	// Z "ovladacho prvku" do dat. prvku m_pSet->m_PBINARY
	{
	/*	CDaoDoc* pDoc = GetDocument();
		int i;		
		for (i = 0; i <= 11; i++)
		  ((pDoc->m_daoSet).m_PBINARY).SetAt(i,i+2);
			
		pDoc->m_daoSet.SetFieldDirty( &(pDoc->m_daoSet).m_PBINARY );
	*/
  }
}

void CDaoView::OnButton1() // GetBinary
{	
	CDaoDoc* pDoc = GetDocument();

	int i, chyba = 0;
	for (i = 0; i <= 11; i++)
	 	if (i+2 == ((pDoc->m_daoSet).m_PBINARY).GetAt(i))
			chyba++ ;
	if (chyba == 12)
			MessageBeep(0);
	
}
